// HP PCL Management
// By Steven Lawrance

#include <windows.h>
#include <ctl3d.h>
#include <commdlg.h>
#include <stdio.h>
#include <string.h>
#include "pclpage.h"

BOOL CALLBACK _export PclPageDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export CmdParamDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void Print(HWND hDlg, char *PrintString);

HINSTANCE ghInstance;

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						 LPSTR lpCmdParam, int nCmdShow)
{
  ghInstance = hInstance;

  Ctl3dRegister(hInstance);
  Ctl3dAutoSubclass(hInstance);

  if (lstrcmp(lpCmdParam, "") == 0)
  {
	 DLGPROC PclPageDlgProcHandle;

	 PclPageDlgProcHandle = (DLGPROC) MakeProcInstance((FARPROC) PclPageDlgProc, hInstance);
	 DialogBox(hInstance, "PCLPAGE", HWND_DESKTOP, PclPageDlgProcHandle);
	 FreeProcInstance((FARPROC) PclPageDlgProcHandle);
  }
  else
  {
	 int bOk = FALSE;

	 switch (lpCmdParam[0])
	 {
		case 'O', 'o' :
		{
		  Print(HWND_DESKTOP, "&l0H");
		  bOk = TRUE;
		  break;
		}
		case 'E', 'e' :
		{
		  Print(HWND_DESKTOP, "&l3H");
		  bOk = TRUE;
		  break;
		}
		case 'I', 'i' :
		{
		  Print(HWND_DESKTOP, "&l1H");
		  bOk = TRUE;
		  break;
		}
	 }

	 if (bOk == FALSE)
	 {
		DLGPROC CmdParamDlgProcHandle;

		CmdParamDlgProcHandle = (DLGPROC) MakeProcInstance((FARPROC) CmdParamDlgProc, hInstance);
		DialogBox(hInstance, "CMDPARAM", HWND_DESKTOP, CmdParamDlgProcHandle);
		FreeProcInstance((FARPROC) CmdParamDlgProcHandle);
	 }
  }

  Ctl3dUnregister(hInstance);

  PostQuitMessage(0);
  return 0;
}

#pragma argsused
BOOL CALLBACK _export PclPageDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
	 case WM_INITDIALOG :
	 {
		Ctl3dSubclassDlgEx(hDlg, CTL3D_ALL);
		return TRUE;
	 }
	 case WM_COMMAND :
	 {
		if (wParam == IDC_LOAD)
		{
		  Print(hDlg, "&l1H");
		  return 0;
		}
		if (wParam == IDC_EJECT)
		{
		  Print(hDlg, "&l0H");
		  return 0;
		}
		if (wParam == IDC_ENVELOPE)
		{
		  Print(hDlg, "&l3H");
		  return 0;
		}
		if (wParam == IDC_HELP)
		{
		  DLGPROC CmdParamDlgProcHandle;

		  CmdParamDlgProcHandle = (DLGPROC) MakeProcInstance((FARPROC) CmdParamDlgProc, ghInstance);
		  DialogBox(ghInstance, "CMDPARAM", hDlg, CmdParamDlgProcHandle);
		  FreeProcInstance((FARPROC) CmdParamDlgProcHandle);
		  return 0;
		}
		if (wParam == 2)
		{
		  EndDialog(hDlg, 0);
		  return 0;
		}
	 }
  }
  return FALSE;
}

void Print(HWND hDlg, char *PrintString)
{
  char NewPrint[10];
  memset(NewPrint, NULL, 10);
  NewPrint[0] = 27;
  strcat(NewPrint, PrintString);
  if (fprintf(stdprn, NewPrint) == EOF)
  {
	 MessageBeep(MB_ICONEXCLAMATION);
	 MessageBox(hDlg, "Cannot Print To Default Printer!", "Print Error", MB_OK | MB_ICONEXCLAMATION);
  }
}

#pragma argsused
BOOL CALLBACK _export CmdParamDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
	 case WM_INITDIALOG :
	 {
		char HelpText[280];
		memset(HelpText, NULL, 280);
		strcpy(HelpText, "PCLPAGE O\tThis Ejects the Page\n");
		strcat(HelpText, "PCLPAGE E\tThis Loads An Envelope\n");
		strcat(HelpText, "PCLPAGE I\tThis Loads A Page");
		SetDlgItemText(hDlg, IDC_HELP, HelpText);

		Ctl3dSubclassDlgEx(hDlg, CTL3D_ALL);
		return TRUE;
	 }
	 case WM_COMMAND :
	 {
		if (wParam == 2)
		{
		  EndDialog(hDlg, 0);
		  return 0;
		}
	 }
  }
  return FALSE;
}

